package com.goldencode.testcases;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.testcases.dmo.vtest.*;

import static com.goldencode.p2j.util.BlockManager.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in Vadim22.p).
 */
public class Vadim22
{
   Btest.Buf btest = RecordBuffer.define(Btest.Buf.class, "vtest", "btest");

   Btest.Buf hbuffer = RecordBuffer.define(Btest.Buf.class, "vtest", "hbuffer");

   final QueryWrapper query0 = new QueryWrapper(false);

   /**
    * External procedure (converted to Java from the 4GL source code
    * in Vadim22.p).
    */
   public void execute()
   {
      externalProcedure(new Block()
      {
         logical log = new logical(false);

         integer int1 = new integer(0);

         rowid row = new rowid();

         handle hBuffer = new handle();

         handle hQuery = new handle();

         handle hBuf = new handle();

         character ch = new character("");

         handle hField = new handle();

         public void init()
         {
            TransactionManager.register(log, int1, row, hBuf);
         }

         public void body()
         {
            RecordBuffer.openScope(btest);
            UnnamedStreams.assignOut(StreamFactory.openFileStream("vadim22_results", true, false));
            hBuf.assign(hBuffer);
            handle.unwrapFieldReference(hBuffer).value();
            handle.unwrapErrorStatus(hBuffer).setError(log);
            log.assign(handle.unwrapErrorStatus(hBuffer).isError());
            log.assign(handle.unwrapP2JQuery(hQuery).getNumResults());
            int1.assign(handle.unwrapQuery(hQuery).getTableCount());
            int1.assign(handle.unwrapBuffer(hBuffer).numFields());
            row.assign(handle.unwrapBuffer(hBuffer).rowId());
            log.assign(handle.unwrapBuffer(hBuffer).characterLocked());
            ch.assign(handle.unwrapBuffer(hBuffer).initial());
            log.assign(handle.unwrapBuffer(hBuffer).ambiguous());
            hField.assign(handle.unwrapBuffer(hBuffer).bufferField(5));
            ch.assign(handle.unwrapFieldReference(hField).columnLabel());
            int1.assign(handle.unwrapFieldReference(hField).extent());
            ch.assign(handle.unwrapFieldReference(hField).format());
            ch.assign(handle.unwrapFieldReference(hField).stringValue());
            handle.unwrapFieldReference(hField).changeValue(handle.unwrapFieldReference(hField).value());
            handle.unwrapFieldReference(hBuffer).changeValue(handle.unwrapFieldReference(hBuffer).value(7));
            handle.unwrapFieldReference(hBuffer).changeValue(4, handle.unwrapFieldReference(hBuffer).value(6));
            handle.unwrapFieldReference(hField).changeColumnLabel(ch);
            ch.assign(handle.unwrapFieldReference(hField).stringValue(1));
         }
      });
   }
}
